## qbittorrent 3.3.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
cmake_policy(VERSION 3.5)

project(qBittorrent VERSION 3.4.0.0)

set(VER_MAJOR ${qBittorrent_VERSION_MAJOR})
set(VER_MINOR ${qBittorrent_VERSION_MINOR})
set(VER_BUGFIX ${qBittorrent_VERSION_PATCH})
set(VER_BUILD ${qBittorrent_VERSION_TWEAK})
set(VER_STATUS "alpha") # Should be empty for stable releases!

# Don't touch the rest part
set(PROJECT_VERSION "${VER_MAJOR}.${VER_MINOR}.${VER_BUGFIX}")

if (NOT VER_BUILD EQUAL 0)
    set(PROJECT_VERSION "${PROJECT_VERSION}.${VER_BUILD}")
endif()

set(PROJECT_VERSION "${PROJECT_VERSION}${VER_STATUS}")

add_definitions(-DVERSION_MAJOR=${VER_MAJOR})
add_definitions(-DVERSION_MINOR=${VER_MINOR})
add_definitions(-DVERSION_BUGFIX=${VER_BUGFIX})
add_definitions(-DVERSION_BUILD=${VER_BUILD})

# os2 {
#     DEFINES += VERSION=\'\"v$${PROJECT_VERSION}\"\'
# } else {
add_definitions(-DVERSION="v${PROJECT_VERSION}")
# }
list(APPEND CMAKE_MODULE_PATH ${qBittorrent_SOURCE_DIR}/cmake/Modules)

# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Og")
if (UNIX AND NOT APPLE)
    include(GNUInstallDirs)
endif (UNIX AND NOT APPLE)

if(WIN32)
    include(winconf)
endif(WIN32)

# we need options here, because they are used not only in "src" subdir, but in the "dist" dir too
include(CMakeDependentOption)

option(QT5 "Compile using Qt5" ON)
option(SYSTEM_QTSINGLEAPPLICATION
    "Use the system qtsingleapplication library or shipped one otherwise")
cmake_dependent_option(SYSTEM_QJSON
    "Use the shipped qjson library or the system one (Qt4 only)" OFF "NOT QT5" OFF)

option(GUI "Allows to disable GUI for headless running. Disables QtDBus and the GeoIP Database" ON)

option(WEBUI "Allows to disable the WebUI." ON)

if (WIN32)
    option(STACKTRACE_WIN "")
else (WIN32)
    cmake_dependent_option(SYSTEMD "Install the systemd service file (headless only)" OFF
        "NOT GUI" OFF)
    cmake_dependent_option(DBUS "Enable use of QtDBus (GUI only)" ON "GUI" OFF)
endif(WIN32)


add_subdirectory(src)
add_subdirectory(dist)

=== src/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD "11")
add_definitions(-DBOOST_NO_CXX11_RVALUE_REFERENCES)

include(MacroLinkQtComponents)
include(QbtTargetSources)

find_package(LibtorrentRasterbar REQUIRED)

# Qt
if (QT5)
    add_definitions(-DQBT_USES_QT5)
    list(APPEND QBT_QT_COMPONENTS Core Network Xml)
    if (GUI)
        list (APPEND QBT_QT_COMPONENTS Concurrent Gui Widgets)
    endif (GUI)
    if (DBUS)
        list (APPEND QBT_QT_COMPONENTS DBus)
    endif (DBUS)
    find_package(Qt5 5.2.0 COMPONENTS ${QBT_QT_COMPONENTS} REQUIRED)
else (QT5)
    list(APPEND QBT_QT_COMPONENTS QtCore QtNetwork QtXml)
    if (GUI)
        list (APPEND QBT_QT_COMPONENTS QtGui)
    endif (GUI)
    if (DBUS)
        list (APPEND QBT_QT_COMPONENTS QtDBus)
    endif (DBUS)
    find_package(Qt4 4.8.0 COMPONENTS ${QBT_QT_COMPONENTS} REQUIRED)
    include(${QT_USE_FILE})
endif (QT5)

set(CMAKE_AUTOMOC True)
list(APPEND CMAKE_AUTORCC_OPTIONS -compress 9 -threshold 5)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# defines
add_definitions(-DQT_NO_CAST_TO_ASCII)
# Fast concatenation (Qt >= 4.6)
add_definitions(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
if (WIN32)
    add_definitions(-DNOMINMAX)
endif (WIN32)

if (NOT GUI)
    add_definitions(-DDISABLE_GUI -DDISABLE_COUNTRIES_RESOLUTION)
endif (NOT GUI)

if (NOT WEBUI)
    add_definitions(-DDISABLE_WEBUI)
endif (NOT WEBUI)

if (STACKTRACE_WIN)
    add_definitions(-DSTACKTRACE_WIN)
endif(STACKTRACE_WIN)
# nogui {
#     TARGET = qbittorrent-nox
# } else {
#     CONFIG(static) {
#         DEFINES += QBT_STATIC_QT
#         QTPLUGIN += qico
#     }
#     TARGET = qbittorrent
# }

if (UNIX AND NOT APPLE)
    add_compile_options(-Wformat -Wformat-security)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "Project is built in DEBUG mode.")
else (CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "Project is built in RELEASE mode.")
    message(STATUS "Disabling debug output.")
    add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")

set(QBT_USE_GUI ${GUI})
set(QBT_USE_WEBUI ${WEBUI})
set(QBT_USES_QT5 ${QT5})

configure_file(config.h.cmakein ${CMAKE_CURRENT_BINARY_DIR}/config.h)

if (GUI)
    set(QBT_TARGET_NAME qbittorrent)
else (GUI)
    set(QBT_TARGET_NAME qbittorrent-nox)
endif (GUI)


if (SYSTEM_QTSINGLEAPPLICATION)
    find_package(QtSingleApplication REQUIRED)
else (SYSTEM_QTSINGLEAPPLICATION)
    add_subdirectory(app/qtsingleapplication)
endif (SYSTEM_QTSINGLEAPPLICATION)

add_subdirectory(app)
add_subdirectory(base)

if (GUI)
    add_subdirectory(gui)
endif (GUI)

if (WEBUI)
    add_subdirectory(webui)
endif (WEBUI)

=== dist/unix/CMakeLists.txt ===
if (SYSTEMD)
    find_package(Systemd)
    if (SYSTEMD_FOUND)
        set(EXPAND_BINDIR ${CMAKE_INSTALL_FULL_BINDIR})
        configure_file(systemd/qbittorrent-nox.service.in ${CMAKE_CURRENT_BINARY_DIR}/qbittorrent-nox.service @ONLY)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qbittorrent-nox.service
            DESTINATION ${SYSTEMD_SERVICES_INSTALL_DIR}
            COMPONENT data)
    endif(SYSTEMD_FOUND)
endif(SYSTEMD)


if (GUI)
    list(APPEND MAN_FILES ${qBittorrent_SOURCE_DIR}/doc/qbittorrent.1)
else (GUI)
    list(APPEND MAN_FILES ${qBittorrent_SOURCE_DIR}/doc/qbittorrent-nox.1)
endif (GUI)

install(FILES ${MAN_FILES}
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
        COMPONENT doc)

install(DIRECTORY menuicons/
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor
        FILES_MATCHING PATTERN "*.png")

install(FILES ${qBittorrent_SOURCE_DIR}/src/icons/qbittorrent.png
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pixmaps/
        COMPONENT data)

install(FILES ${qBittorrent_SOURCE_DIR}/src/icons/qBittorrent.desktop
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications/
        COMPONENT data)

install(FILES qBittorrent.appdata.xml
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/appdata/
        COMPONENT data)

=== src/base/CMakeLists.txt ===
find_package(ZLIB REQUIRED)

set(QBT_BASE_HEADERS
bittorrent/cachestatus.h
bittorrent/infohash.h
bittorrent/magneturi.h
bittorrent/peerinfo.h
bittorrent/private/bandwidthscheduler.h
bittorrent/private/filterparserthread.h
bittorrent/private/resumedatasavingmanager.h
bittorrent/private/speedmonitor.h
bittorrent/private/statistics.h
bittorrent/session.h
bittorrent/sessionstatus.h
bittorrent/torrentcreatorthread.h
bittorrent/torrenthandle.h
bittorrent/torrentinfo.h
bittorrent/tracker.h
bittorrent/trackerentry.h
http/connection.h
http/irequesthandler.h
http/requestparser.h
http/responsebuilder.h
http/responsegenerator.h
http/server.h
http/types.h
net/dnsupdater.h
net/downloadhandler.h
net/downloadmanager.h
net/geoipmanager.h
net/portforwarder.h
net/private/geoipdatabase.h
net/reverseresolution.h
net/smtp.h
rss/private/rssparser.h
rss/rssarticle.h
rss/rssdownloadrule.h
rss/rssdownloadrulelist.h
rss/rssfeed.h
rss/rssfile.h
rss/rssfolder.h
rss/rssmanager.h
utils/fs.h
utils/gzip.h
utils/misc.h
utils/string.h
filesystemwatcher.h
iconprovider.h
indexrange.h
logger.h
preferences.h
qinisettings.h
scanfoldersmodel.h
searchengine.h
settingsstorage.h
torrentfileguard.h
torrentfilter.h
tristatebool.h
types.h
unicodestrings.h
)

set(QBT_BASE_SOURCES
bittorrent/cachestatus.cpp
bittorrent/infohash.cpp
bittorrent/magneturi.cpp
bittorrent/peerinfo.cpp
bittorrent/private/bandwidthscheduler.cpp
bittorrent/private/filterparserthread.cpp
bittorrent/private/resumedatasavingmanager.cpp
bittorrent/private/speedmonitor.cpp
bittorrent/private/statistics.cpp
bittorrent/session.cpp
bittorrent/sessionstatus.cpp
bittorrent/torrentcreatorthread.cpp
bittorrent/torrenthandle.cpp
bittorrent/torrentinfo.cpp
bittorrent/tracker.cpp
bittorrent/trackerentry.cpp
http/connection.cpp
http/requestparser.cpp
http/responsebuilder.cpp
http/responsegenerator.cpp
http/server.cpp
net/dnsupdater.cpp
net/downloadhandler.cpp
net/downloadmanager.cpp
net/geoipmanager.cpp
net/portforwarder.cpp
net/private/geoipdatabase.cpp
net/reverseresolution.cpp
net/smtp.cpp
rss/private/rssparser.cpp
rss/rssarticle.cpp
rss/rssdownloadrule.cpp
rss/rssdownloadrulelist.cpp
rss/rssfeed.cpp
rss/rssfile.cpp
rss/rssfolder.cpp
rss/rssmanager.cpp
utils/fs.cpp
utils/gzip.cpp
utils/misc.cpp
utils/string.cpp
filesystemwatcher.cpp
iconprovider.cpp
logger.cpp
preferences.cpp
scanfoldersmodel.cpp
searchengine.cpp
settingsstorage.cpp
torrentfileguard.cpp
torrentfilter.cpp
tristatebool.cpp
)

add_library(qbt_base STATIC ${QBT_BASE_HEADERS} ${QBT_BASE_SOURCES})
target_link_libraries(qbt_base ZLIB::ZLIB LibtorrentRasterbar::LibTorrent)
target_link_qt_components(qbt_base Core Network Xml)
if (QT4_FOUND)
    if (GUI)
        target_link_libraries(qbt_base Qt4::QtGui)
    endif (GUI)
else (QT4_FOUND)
    if (GUI)
        target_link_libraries(qbt_base Qt5::Gui Qt5::Widgets)
    endif (GUI)
endif (QT4_FOUND)

if (DBUS)
    target_link_qt_components(qbt_base DBus)
endif ()

if (APPLE)
    find_library(IOKit_LIBRARY IOKit)
    find_library(Carbon_LIBRARY Carbon)
    target_link_libraries(qbt_base ${Carbon_LIBRARY} ${IOKit_LIBRARY})
endif (APPLE)

=== src/gui/CMakeLists.txt ===
set(CMAKE_AUTORCC True)
set(CMAKE_AUTOUIC True)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(lineedit)
add_subdirectory(properties)
add_subdirectory(powermanagement)
add_subdirectory(rss)
add_subdirectory(search)

if (UNIX AND NOT APPLE AND DBUS)
   add_subdirectory(qtnotify)
   include_directories(qtnotify)
   list(APPEND QBT_GUI_OPTIONAL_LINK_LIBRARIES qbt_qtnotify)
endif (UNIX AND NOT APPLE AND DBUS)

include_directories(
${CMAKE_CURRENT_BINARY_DIR}/properties
${CMAKE_CURRENT_BINARY_DIR}/rss
${CMAKE_CURRENT_BINARY_DIR}/search
lineedit/src
powermanagement
properties
rss
../app
)

set(QBT_GUI_HEADERS
about_imp.h
addnewtorrentdialog.h
advancedsettings.h
advancedsettings.h
autoexpandabledialog.h
cookiesdialog.h
cookiesmodel.h
deletionconfirmationdlg.h
downloadfromurldlg.h
executionlog.h
guiiconprovider.h
hidabletabwidget.h
ico.h
loglistwidget.h
mainwindow.h
messageboxraised.h
optionsdlg.h
previewlistdelegate.h
previewselect.h
scanfoldersdelegate.h
shutdownconfirmdlg.h
speedlimitdlg.h
statsdialog.h
statusbar.h
torrentcontentfiltermodel.h
torrentcontentmodel.h
torrentcontentmodelfile.h
torrentcontentmodelfolder.h
torrentcontentmodelitem.h
torrentcontenttreeview.h
torrentcreatordlg.h
torrentmodel.h
trackerlogin.h
transferlistdelegate.h
transferlistfilterswidget.h
transferlistsortmodel.h
transferlistwidget.h
updownratiodlg.h
)

set(QBT_GUI_SOURCES
addnewtorrentdialog.cpp
advancedsettings.cpp
autoexpandabledialog.cpp
cookiesdialog.cpp
cookiesmodel.cpp
executionlog.cpp
guiiconprovider.cpp
ico.cpp
loglistwidget.cpp
mainwindow.cpp
messageboxraised.cpp
optionsdlg.cpp
previewselect.cpp
scanfoldersdelegate.cpp
shutdownconfirmdlg.cpp
speedlimitdlg.cpp
statsdialog.cpp
statusbar.cpp
torrentcontentfiltermodel.cpp
torrentcontentmodel.cpp
torrentcontentmodelfile.cpp
torrentcontentmodelfolder.cpp
torrentcontentmodelitem.cpp
torrentcontenttreeview.cpp
torrentcreatordlg.cpp
torrentmodel.cpp
trackerlogin.cpp
transferlistdelegate.cpp
transferlistfilterswidget.cpp
transferlistsortmodel.cpp
transferlistwidget.cpp
updownratiodlg.cpp
)

if (WIN32 OR APPLE)
    list(APPEND QBT_GUI_HEADERS programupdater.h)
    list(APPEND QBT_GUI_SOURCES programupdater.cpp)
endif (WIN32 OR APPLE)

set(QBT_GUI_FORMS
mainwindow.ui
about.ui
cookiesdialog.ui
preview.ui
login.ui
downloadfromurldlg.ui
bandwidth_limit.ui
updownratiodlg.ui
confirmdeletiondlg.ui
executionlog.ui
addnewtorrentdialog.ui
autoexpandabledialog.ui
statsdialog.ui
optionsdlg.ui
torrentcreatordlg.ui
shutdownconfirmdlg.ui
)

qbt_target_sources(about.qrc)

add_library(qbt_gui STATIC ${QBT_GUI_HEADERS} ${QBT_GUI_SOURCES})
target_link_libraries(qbt_gui qbt_lineedit qbt_powermanagement qbt_rss qbt_properties qbt_searchengine
    ${QBT_GUI_OPTIONAL_LINK_LIBRARIES} qbt_base
    QtSingleApplication::QtSingleApplication
)

=== src/webui/CMakeLists.txt ===
set(QBT_WEBUI_HEADERS
abstractwebapplication.h
btjson.h
extra_translations.h
jsonutils.h
prefjson.h
webapplication.h
websessiondata.h
webui.h
)

set(QBT_WEBUI_SOURCES
abstractwebapplication.cpp
btjson.cpp
prefjson.cpp
webapplication.cpp
webui.cpp
)

if (QT4_FOUND)
    if (NOT SYSTEM_QJSON)
        add_subdirectory(qjson)
    else (NOT SYSTEM_QJSON)
        find_package(QJSON REQUIRED)
        add_definitions(-DUSE_SYSTEM_QJSON)
    endif(NOT SYSTEM_QJSON)
endif (QT4_FOUND)

qbt_target_sources(webui.qrc)

add_library(qbt_webui STATIC ${QBT_WEBUI_HEADERS} ${QBT_WEBUI_SOURCES})
target_link_libraries(qbt_webui qbt_base)

if (QT4_FOUND)
    target_link_libraries(qbt_webui qjson)
endif (QT4_FOUND)

=== src/app/qtsingleapplication/CMakeLists.txt ===
project(qtsingleapplication)

set(QBT_QTSINGLEAPPLICATION_HEADERS
qtlocalpeer.h
)

set(QBT_QTSINGLEAPPLICATION_SOURCES
qtlocalpeer.cpp
)

if (GUI)
    list(APPEND QBT_QTSINGLEAPPLICATION_HEADERS qtsingleapplication.h)
    list(APPEND QBT_QTSINGLEAPPLICATION_SOURCES qtsingleapplication.cpp)
else (GUI)
    list(APPEND QBT_QTSINGLEAPPLICATION_HEADERS qtsinglecoreapplication.h)
    list(APPEND QBT_QTSINGLEAPPLICATION_SOURCES qtsinglecoreapplication.cpp)
endif (GUI)

add_library(qtsingleapplication ${QBT_QTSINGLEAPPLICATION_HEADERS} ${QBT_QTSINGLEAPPLICATION_SOURCES})
target_include_directories(qtsingleapplication INTERFACE "${qtsingleapplication_SOURCE_DIR}")

if (QT4_FOUND)
    target_link_libraries(qtsingleapplication Qt4::QtNetwork)
else (QT4_FOUND)
    target_link_libraries(qtsingleapplication Qt5::Network)
endif (QT4_FOUND)

if (GUI)
    if (QT4_FOUND)
        target_link_libraries(qtsingleapplication Qt4::QtGui)
    else (QT4_FOUND)
        target_link_libraries(qtsingleapplication Qt5::Widgets)
    endif(QT4_FOUND)
endif (GUI)

add_library(QtSingleApplication::QtSingleApplication ALIAS qtsingleapplication)

=== src/gui/properties/CMakeLists.txt ===
include_directories(
${CMAKE_CURRENT_BINARY_DIR}
${CMAKE_CURRENT_SOURCE_DIR}
../lineedit/src/
)

set(QBT_PROPERTIES_FORMS
propertieswidget.ui
trackersadditiondlg.ui
peersadditiondlg.ui
)

set(QBT_PROPERTIES_HEADERS
propertieswidget.h
peerlistwidget.h
proplistdelegate.h
trackerlist.h
downloadedpiecesbar.h
piecesbar.h
peerlistdelegate.h
peerlistsortmodel.h
peersadditiondlg.h
trackersadditiondlg.h
pieceavailabilitybar.h
proptabbar.h
speedwidget.h
speedplotview.h
)

set(QBT_PROPERTIES_SOURCES
propertieswidget.cpp
proplistdelegate.cpp
peerlistwidget.cpp
trackerlist.cpp
peersadditiondlg.cpp
downloadedpiecesbar.cpp
piecesbar.cpp
trackersadditiondlg.cpp
pieceavailabilitybar.cpp
proptabbar.cpp
speedwidget.cpp
speedplotview.cpp
)

add_library(qbt_properties STATIC ${QBT_PROPERTIES_HEADERS} ${QBT_PROPERTIES_SOURCES})
target_link_libraries(qbt_properties qbt_base)
if (NOT QT4_FOUND)
    target_link_libraries(qbt_properties Qt5::Widgets Qt5::Concurrent)
endif (NOT QT4_FOUND)

=== src/gui/rss/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

set(QBT_RSS_HEADERS
automatedrssdownloader.h
feedlistwidget.h
htmlbrowser.h
rss_imp.h
rsssettingsdlg.h
)

set(QBT_RSS_SOURCE
automatedrssdownloader.cpp
feedlistwidget.cpp
htmlbrowser.cpp
rss_imp.cpp
rsssettingsdlg.cpp
)

set(QBT_RSS_FORMS
automatedrssdownloader.ui
rss.ui
rsssettingsdlg.ui
)

add_library(qbt_rss STATIC ${QBT_RSS_HEADERS} ${QBT_RSS_SOURCE} ${QBT_RSS_FORMS})
if (QT4_FOUND)
    target_link_libraries(qbt_rss Qt4::QtGui Qt4::QtNetwork)
else (QT4_FOUND)
    target_link_libraries(qbt_rss Qt5::Gui Qt5::Widgets Qt5::Network)
endif (QT4_FOUND)

=== src/gui/search/CMakeLists.txt ===
include_directories(
${CMAKE_CURRENT_BINARY_DIR}
${CMAKE_CURRENT_SOURCE_DIR}/..
${CMAKE_CURRENT_SOURCE_DIR}/../lineedit/src
)

set(QBT_SEARCHENGINE_FORMS
pluginselectdlg.ui
pluginsourcedlg.ui
searchwidget.ui
)

set(QBT_SEARCHENGINE_HEADERS
pluginselectdlg.h
pluginsourcedlg.h
searchlistdelegate.h
searchsortmodel.h
searchtab.h
searchwidget.h
)

set(QBT_SEARCHENGINE_SOURCES
pluginselectdlg.cpp
pluginsourcedlg.cpp
searchlistdelegate.cpp
searchsortmodel.cpp
searchtab.cpp
searchwidget.cpp
../ico.cpp
)

set(QBT_SEARCHENGINE_RESOURCES
# search.qrc
)

add_library(qbt_searchengine STATIC ${QBT_SEARCHENGINE_HEADERS} ${QBT_SEARCHENGINE_SOURCES} ${QBT_SEARCHENGINE_RESOURCES} ${QBT_SEARCHENGINE_FORMS})
target_link_libraries(qbt_searchengine qbt_base)

=== src/webui/qjson/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
set(QJSON_HEADERS
FlexLexer.h
stack.hh
position.hh
location.hh
json_parser.hh
json_scanner.h
parser.h
parser_p.h
qjson_debug.h
qjson_export.h
serializer.h
)

set(QJSON_SOURCES
json_parser.cc
json_scanner.cc
json_scanner.cpp
parser.cpp
serializer.cpp
)

add_library(qjson STATIC ${QJSON_HEADERS} ${QJSON_SOURCES})

=== debian/changelog ===
qbittorrent (3.3.7-3+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Prevent command injection via "Run external program" function
    (CVE-2019-13640) (Closes: #932539)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 29 Mar 2020 17:45:52 +0200

qbittorrent (3.3.7-3) unstable; urgency=medium

  * CVE-2017-6503: Escape values in WebUI to prevent
    potential XSS (Closes: #856977).
  * CVE-2017-6504: Set the X-Frame-Options header to
    prevent potential clickjacking (Closes: #856978).

 -- Andrew Starr-Bochicchio <asb@debian.org>  Sun, 12 Mar 2017 21:04:51 -0400

qbittorrent (3.3.7-2) unstable; urgency=medium

  * Explicitly build depend on zlib1g-dev (Closes: #845619).

 -- Andrew Starr-Bochicchio <asb@debian.org>  Sun, 27 Nov 2016 11:46:59 -0500

qbittorrent (3.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Replace mentions of Qt4 with Qt5 in the package
    description (Closes: #834508).
  * debian/rules: Set INSTALL_ROOT for dh_auto_install
    (Closes: #840176). 
  * Bump debian/compat to level 10.
  * debian/rules: Pass '--without autoreconf' to dh as autoreconf
    is now used by default with compat level 10.

 -- Andrew Starr-Bochicchio <asb@debian.org>  Sat, 29 Oct 2016 17:34:11 -0400

=== debian/control ===
Source: qbittorrent
Section: net
Priority: optional
Maintainer: Cristian Greco <cristian@debian.org>
Uploaders: Andrew Starr-Bochicchio <asb@debian.org>
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.16.1),
               libtorrent-rasterbar-dev (>= 0.15.4),
               libboost-dev,
               qtbase5-dev (>= 5.2.0),
               qttools5-dev-tools,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Git: git://anonscm.debian.org/collab-maint/qbittorrent.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/qbittorrent.git
Homepage: http://www.qbittorrent.org/

Package: qbittorrent
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         python (>= 2.5), geoip-database
Suggests: qbittorrent-dbg
Description: bittorrent client based on libtorrent-rasterbar with a Qt5 GUI
 BitTorrent client written in C++ and based on libtorrent-rasterbar with a Qt5
 user interface. qBittorrent is a feature rich but lightweight client that is
 very similar to uTorrent. Its main features are:
 .
  * Polished uTorrent-like user interface
  * Well integrated and extensible search engine
  * Remote control through a Web user interface
  * Vuze-compatible protocol encryption
  * uTorrent-compatible Peer eXchange (PeX)
  * DHT (trackerless) support
  * UPnP / NAT-PMP port forwarding
  * IPv6 compliant
  * RSS support with advanced download filters
  * Advanced control over torrent content and trackers
  * IP Filtering (eMule / Peer Guardian filters)
  * Torrents queueing and prioritizing
  * Good localization (~25 languages supported)
  * Unicode support

Package: qbittorrent-nox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: qbittorrent-dbg
Description: bittorrent client based on libtorrent-rasterbar (without X support)
 BitTorrent client written in C++ and based on libtorrent-rasterbar.
 qBittorrent-nox is a version of qBittorrent (Qt5 application) that does not
 require X and can be controlled via a WebUI, thus is more suitable for headless
 servers. It is a feature rich but lightweight client that is very similar to
 rTorrent. Its main features are:
 .
  * Remote control through a Web user interface
  * Vuze-compatible protocol encryption
  * uTorrent-compatible Peer eXchange (PeX)
  * DHT (trackerless) support
  * UPnP / NAT-PMP port forwarding
  * IPv6 compliant
  * Advanced control over torrent content and trackers
  * IP Filtering (eMule / Peer Guardian filters)
  * Torrents queueing and prioritizing
  * Good localization (~25 languages supported)
  * Unicode support

Package: qbittorrent-dbg
Architecture: any
Section: debug
Priority: extra
Depends: qbittorrent (= ${binary:Version}) | qbittorrent-nox (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for qbittorrent and qbittorrent-nox
 BitTorrent client written in C++ and based on libtorrent-rasterbar with a Qt5
 user interface. qBittorrent is a feature rich but lightweight client that is
 very similar to uTorrent.
 .
 This package contains the debugging symbols for qbittorrent and
 qbittorrent-nox.

## qbittorrent 3.3.16

=== debian/changelog ===
qbittorrent (3.3.16-0mx15+1) mx; urgency=medium

  * New bugfix release:
    - BUGFIX: Better memory footprint when using libtorrent 1.1.x. The cache is
      turned off by default(`0 (disabled)` value in the settings). The value
      `-1 (auto)` makes it use 1/8 of your RAM. 
    - BUGFIX: Skip user input events when adding torrent. Closes #7327.
    - BUGFIX: Avoid memory leak in the speed graph. 
    - WEBUI: Fix validating wrong header field. X-Forwarded-Host is a foreign
      proxy setting, it isn't the same as qbt's local setting and thus it makes
      no sense to verify it. Closes #7311. 

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 25 Sep 2017 13:43:16 -0700

qbittorrent (3.3.15-0mx15+1) mx; urgency=medium

  * New bugfix release:
    - BUGFIX: Temporary subfolder wasn't being deleted. (glassez)
  * debian/control:  remove any specific Qt 4 or 5 references in descriptions,
    since this will change depending on the distrelease.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 06 Sep 2017 12:29:47 -0700

qbittorrent (3.3.14-0mx15+1) mx; urgency=medium

  * New upstream release:
    - BUGFIX: Set interface for outgoing traffic(libtorrent 1.1.x
      series). (evsh)
    - WEBUI: Fix KEEP_ALIVE_DURATION value (Chocobo1)
    - WEBUI: Relax CSRF defense. Closes #6882. Allow HTTP request
      which has neither Origin nor Referer header included. (Chocobo1)
    - WEBUI: Skip username/password check for active sessions (closes
      #6860) (Thomas Piccirello)
    - WEBUI: Fix javascript errors and follow best practices (Thomas Piccirello)
    - WEBUI: Fix value comparison. Closes #7081. (Chocobo1)
    - WEBUI: Avoid modifying request headers (Chocobo1)
    - WEBUI: Implement HTTP host header filtering. This filtering is required
      to defend against DNS rebinding attack. Fixes security issues reported by
      @beardog108 privately. (Chocobo1)
    - WEBUI: Add Status column to webui (addresses #6815)
      (#7032) (Tom Piccirello)
    - WEBUI: Bump API_VERSION and API_VERSION_MIN to 15.
    - SEARCH: Pad shorter python versions. Closes #6877. (sledgehammer999)
    - WINDOWS: Updated Arabic, Turkish, Greek, Russian, Danish languages of the
      installer. (KingLucius, BouRock, thalieht, Andrei Stepanov, scootergrisen)
    - WINDOWS: Raise total stack size on Windows to 8 MB.
      Closes #7021. (Chocobo1)
    - LINUX: Systemd service with user switch and other fixes/optimizations.
      (anton.latukha)

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 24 Jul 2017 08:12:46 -0700

qbittorrent (3.3.13-0mx15+2) MX; urgency=medium

  * debian/control and rules:  alternative B-D and config logic to use Qt 4 on
    a Jessie base, Qt 5 if newer with Qt5 (>= 5.4)
  * Minimum version of libtorrent-rasterbar-dev is now 1.1.2.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 03 Jul 2017 15:47:55 -0700

qbittorrent (3.3.13-0mx15+1) mx; urgency=medium

  * New upstream bugfix release.
    - BUGFIX: Fixed UI glitch about torrent numbers in the sidepanel.
      Fixes #6454. (evsh)
    - BUGFIX: Fix downloaded/uploaded columns were not highlighted properly
      when selected. (Chocobo1)
    - BUGFIX: Always draw background in files list and search result
      list (Chocobo1)
    - BUGFIX: Remove torrent temp folder if it becomes unneeded (glassez)
    - BUGFIX: Remove torrent temp folder when torrent is deleted (glassez)
    - BUGFIX: Setup DPI at startup (Chocobo1)
    - BUGFIX: Do not attempt to show detailed tooltips without torrent
      metadata. Closes #6768. (evsh)
    - BUGFIX: Better detection of already present files when adding a torrent.
      (fbriere)
    - BUGFIX: Fix double click on system tray icon causing program to open and
      minimize immediately. Closes #5826. (Chocobo1)
    - BUGIFX: Fix categories sorting in AddNewTorrentDialog. Partially fixes
      #6708. (fbriere)
    - BUGFIX: Set "category" column as case-insensitive in transfer list.
      (fbriere)
    - BUGFIX: Properly sort categories case-insensitively in filter widget.
      Closes #6708. (fbriere)
    - BUGFIX: Fix renaming files is not case sensitive on Windows platform.
      Closes #5128. (Chocobo1)
    - BUGFIX: Fix crash in download piece bar (evsh)
    - BUGFIX: Fix focusing on the previously opened dialog didn't work
      (Chocobo1)
    - WEBUI: Bugfix: `RequestParser::splitMultipartData` drop extra trailing
      newline. (OpenGG)
    - WEBUI: Add `skip_checking` and `paused` to `/command/download` and
      `/command/upload` (OpenGG)
    - WEBUI: Fix checkbox hidden. Closes #6642. (Chocobo1)
    - WEBUI: Implement http persistence connection. Max simultaneous connection
      limit set to 500. This also release allocated memory of Connection
      instances at runtime instead of at program shutdown. (Chocobo1)
    - WEBUI: Always send Content-Length header. (Chocobo1)
    - WEBUI: Send Date http header (Chocobo1)
    - WEBUI: Fix "Content-Encoding" header is always created. (Chocobo1)
    - WEBUI: Implement robust checking for gzip encoding and revise gzip
      compressing/decompressing code. (Chocobo1)
    - WEBUI: Make the context obligatory for translatable strings. Also delete
      duplicate strings from extra translations. (sledgehammer999)
    - WEBUI: Use translatable strings in Statistics dialog. (sledgehammer999)
    - WEBUI: Add missing unit sizes in misc.js (sledgehammer999)
    - WEBUI: Use the same layout in the Speed tab in preferences as the GUI.
      (sledgehammer999)
    - WEBUI: Return status indicating if at least one torrent was successfully
      added (Thomas Piccirello)
    - WEBUI: Increase the number of digits after the decimal point (thalieht)
    - WEBUI: Use less permissive Content Security Policy (Thomas Piccirello)
    - WEBUI: Fix connection status icon too large. Closes #6804. (Chocobo1)
    - WEBUI: Cosmetic fixes for WebUI upload and download windows (naikel)
    - WEBUI: Fix slow filtering in WebUI. (naikel)
    - WEBUI: Make cookie parsing robust (Chocobo1)


=== debian/control ===
--- 
+++ 
@@ -1,16 +1,19 @@
 Source: qbittorrent
 Section: net
 Priority: optional
-Maintainer: Cristian Greco <cristian@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+Bugs: mailto: maintainer@mxlinux.org
+XSBC-Original-Maintainer: Cristian Greco <cristian@debian.org>
 Uploaders: Andrew Starr-Bochicchio <asb@debian.org>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 9),
+               lsb-release,
                dpkg-dev (>= 1.16.1),
-               libtorrent-rasterbar-dev (>= 0.15.4),
+               libtorrent-rasterbar-dev (>= 1.1.2),
                libboost-dev,
-               qtbase5-dev (>= 5.2.0),
-               qttools5-dev-tools,
+               qtbase5-dev (>= 5.4.0) | libqt4-dev (>= 4:4.8.0),
+               qttools5-dev-tools (>= 5.4.0) | libqt4-dev (>= 4:4.8.0),
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Vcs-Git: git://anonscm.debian.org/collab-maint/qbittorrent.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/qbittorrent.git
 Homepage: http://www.qbittorrent.org/
@@ -20,8 +23,8 @@
 Depends: ${shlibs:Depends}, ${misc:Depends},
          python (>= 2.5), geoip-database
 Suggests: qbittorrent-dbg
-Description: bittorrent client based on libtorrent-rasterbar with a Qt5 GUI
- BitTorrent client written in C++ and based on libtorrent-rasterbar with a Qt5
+Description: bittorrent client based on libtorrent-rasterbar with a Qt GUI
+ BitTorrent client written in C++ and based on libtorrent-rasterbar with a Qt
  user interface. qBittorrent is a feature rich but lightweight client that is
  very similar to uTorrent. Its main features are:
  .
@@ -46,7 +49,7 @@
 Suggests: qbittorrent-dbg
 Description: bittorrent client based on libtorrent-rasterbar (without X support)
  BitTorrent client written in C++ and based on libtorrent-rasterbar.
- qBittorrent-nox is a version of qBittorrent (Qt5 application) that does not
+ qBittorrent-nox is a version of qBittorrent (Qt application) that does not
  require X and can be controlled via a WebUI, thus is more suitable for headless
  servers. It is a feature rich but lightweight client that is very similar to
  rTorrent. Its main features are:
@@ -66,10 +69,9 @@
 Package: qbittorrent-dbg
 Architecture: any
 Section: debug
-Priority: extra
 Depends: qbittorrent (= ${binary:Version}) | qbittorrent-nox (= ${binary:Version}), ${misc:Depends}
 Description: debug symbols for qbittorrent and qbittorrent-nox
- BitTorrent client written in C++ and based on libtorrent-rasterbar with a Qt5
+ BitTorrent client written in C++ and based on libtorrent-rasterbar with a Qt
  user interface. qBittorrent is a feature rich but lightweight client that is
  very similar to uTorrent.
  .

=== debian/rules ===
#!/usr/bin/make -f


DPKG_EXPORT_BUILDFLAGS = 1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
include /usr/share/dpkg/buildflags.mk
distrelease := $(shell lsb_release -cs)

%:
	dh $@  --without autoreconf --parallel

# use Qt 4 on listed distrelease, otherwise use Qt 5
ifeq ($(distrelease),$(filter $(distrelease),jessie Fusion Metamorphosis))
override_dh_auto_configure:
	mkdir -p build-nox && cd build-nox && ../configure --prefix=/usr --disable-gui \
	--with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	--with-qt4
	mkdir -p build-gui && cd build-gui && ../configure --prefix=/usr \
	--with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	--with-qt4
else
override_dh_auto_configure:
	mkdir -p build-nox && cd build-nox && ../configure --prefix=/usr --disable-gui \
	--with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
	mkdir -p build-gui && cd build-gui && ../configure --prefix=/usr \
	--with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
endif

override_dh_auto_build:
	dh_auto_build --builddirectory build-nox
	dh_auto_build --builddirectory build-gui

override_dh_auto_install:
	sed -i '/STRIP/d' build-nox/src/Makefile
	sed -i '/STRIP/d' build-gui/src/Makefile
	dh_auto_install --builddirectory build-nox --destdir debian/qbittorrent-nox \
		-- INSTALL_ROOT=$(CURDIR)/debian/qbittorrent-nox
	dh_auto_install --builddirectory build-gui --destdir debian/qbittorrent \
		-- INSTALL_ROOT=$(CURDIR)/debian/qbittorrent

override_dh_auto_clean:
	dh_auto_clean --builddirectory build-nox
	dh_auto_clean --builddirectory build-gui
	rm -f src/lang/*.qm

override_dh_strip:
	dh_strip -a --dbg-package=qbittorrent-dbg
